package com.vendor.platform.core.externaltools;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.core.externaltools.model.ExternalTool;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.eclipse.core.runtime.Platform;
import org.eclipse.osgi.service.datalocation.Location;

public class ToolsLoader {
  private static final String EXTERNAL_FOLDER = "ExternalTools";
  
  private static final String TOOLS_XML = "tools.xml";
  
  public static final com.vendor.platform.core.externaltools.ToolsLoader instance = new com.vendor.platform.core.externaltools.ToolsLoader();
  
  private List<ExternalTool> externalTools = null;
  
  private Exception e = null;
  
  private ToolsLoader() {
    try {
      this.externalTools = parseTools();
    } catch (Exception e) {
      this.e = e;
    } 
  }
  
  public List<ExternalTool> getExternalTools() throws Exception {
    if (this.e != null)
      throw this.e; 
    return this.externalTools;
  }
  
  public File findsubfilesInExternalFolder(String subPath) {
    File subFile = new File(findExternalFolder(), subPath);
    return subFile;
  }
  
  private File findExternalFolder() {
    Location installLocation = Platform.getInstallLocation();
    String file = installLocation.getURL().getFile();
    File installFolder = new File(file);
    return new File(installFolder, "ExternalTools");
  }
  
  private List<ExternalTool> parseTools() throws Exception {
    List<ExternalTool> list = new ArrayList<>();
    File toolsXML = findsubfilesInExternalFolder("tools.xml");
    SAXReader reader = new SAXReader();
    reader.setFeature("http://apache.org/xml/features/disallow-doctype-decl", true);
    Document document = null;
    InputStream in = null;
    try {
      in = new FileInputStream(toolsXML);
      reader.setFeature("http://xml.org/sax/features/external-general-entities", false);
      reader.setFeature("http://xml.org/sax/features/external-parameter-entities", false);
      document = reader.read(in);
      Element root = document.getRootElement();
      for (Iterator<Element> i_pe = root.elementIterator(); i_pe.hasNext(); ) {
        Element e_pe = i_pe.next();
        String nameCNAttr = e_pe.attributeValue("nameCN");
        if (nameCNAttr == null || nameCNAttr.length() == 0)
          nameCNAttr = ""; 
        String nameENAttr = e_pe.attributeValue("nameEN");
        if (nameENAttr == null || nameENAttr.length() == 0)
          nameENAttr = ""; 
        String exePath = convert(e_pe, "exePath");
        String descEN = convert(e_pe, "descEN");
        String descCN = convert(e_pe, "descCN");
        String iconPath = convert(e_pe, "iconPath");
        String docEN = convert(e_pe, "docEN");
        String docCN = convert(e_pe, "docCN");
        String chipName = convert(e_pe, "chipName");
        ExternalTool tool = new ExternalTool();
        tool.setNameCNAttr(nameCNAttr);
        tool.setNameENAttr(nameENAttr);
        tool.setDescCN(descCN);
        tool.setDescEN(descEN);
        tool.setIconPath(iconPath);
        tool.setExePath(exePath);
        tool.setDocCN(docCN);
        tool.setDocEN(docEN);
        tool.setChipName(chipName);
        list.add(tool);
      } 
    } catch (Exception e) {
      throw e;
    } finally {
      if (in != null)
        in.close(); 
    } 
    return list;
  }
  
  private String convert(Element e_pe, String elementName) {
    try {
      return e_pe.element(elementName).getText();
    } catch (Exception e) {
      return "";
    } 
  }
}
